Bug 237477 - multiple copies of statically-linked libltdl
multiple copies of statically-linked libltdl
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: unixODBC (Show other bugs)
11
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tom Lane
David Lawrence
:
Depends On:
Blocks: 216179
  Show dependency treegraph
 
Reported: 2007-04-23 09:20 EDT by Joe Orton
Modified: 2013-07-02 23:12 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-03-15 12:29:28 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Joe Orton 2007-04-23 09:20:01 EDT
Description of problem:
libodbcpsql, libodbcinst and libtemplate all statically link copies of libltdl:

# nm -D /usr/lib/libodbcinst.so.1.0.0  | grep lt_
4e8e41f0 T lt_dladderror
4e8e4b90 T lt_dladdsearchdir
4e8e3d00 T lt_dlcaller_get_data
...
Comment 1 Tom Lane 2008-02-11 19:11:38 EST
Is this a big problem?  The changelog notes
Use private libltdl so we can omit RTLD_GLOBAL from dlopen flags (bz #161399)
so I'm worried about suffering a regression if we try to use libltdl.so.
Comment 2 Joe Orton 2008-02-12 11:38:59 EST
The copy is not really "private" since it exposes global symbols.  Impact of
this type of issue is:

1) bloat in shipped packages and on disk after installation by shipping N copies
of the same code
2) symbol conflicts when some other library uses this libraries lt_blah symbol
rather than the system libltdl's.  If the local copy is modified and/or has a
different ABI to the system libltdl this can be a big problem.
3) the stale copy of the copied library has bugs not fixed by the system libltdl

Solving (2) without (1) is possible by ensuring the lt_* symbols exposed here
are not made global symbols, e.g. by linking the library using
-export-symbols-regex <SOMETHING> to limit the symbols which are exported.
Comment 3 Bug Zapper 2008-05-13 22:47:35 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Bug Zapper 2009-06-09 18:33:23 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Tom Lane 2009-06-09 19:21:02 EDT
I had forgotten about this bug, but it seems to be fixed as of F11, as a consequence of updating unixODBC to 2.2.14:

$ nm -D /usr/lib64/libodbcinst.so.2.0.0  | grep lt_
                 U lt_dlclose
                 U lt_dlerror
                 U lt_dlinit
                 U lt_dlopen
                 U lt_dlsym
$ 

Would you confirm it looks okay now?

Note You need to log in before you can comment on or make changes to this bug.